package gr.uoi.binarycalculator;

import androidx.appcompat.app.AppCompatActivity;

import android.graphics.Color;
import android.graphics.PorterDuff;
import android.graphics.Typeface;
import android.os.Bundle;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {



        LinearLayout mainLayout =null;
        BinaryNumber first,second;
        TableLayout praxeis=null;
        TableRow row1=null,row2=null,row3=null;
        TextView result=null;
        ImageView zero,one,minus,plus,clear,equals;
        int whichTurn=0;//0 or 1 (variables first,second)
        int lastOperation=0;//0 for plus 1 for minus
        @Override
        protected void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            mainLayout=new LinearLayout(this);
            setContentView(mainLayout);
            Display display = getWindowManager().getDefaultDisplay();
            int width = display.getWidth();
            int height = display.getHeight();
            mainLayout.setOrientation(LinearLayout.VERTICAL);
            result=new TextView(this);
            result.setText("0");
            result.setBackgroundColor(Color.DKGRAY);
            result.setTypeface(null, Typeface.BOLD);
            result.setTextColor(Color.WHITE);
            result.setTextSize(20);
            mainLayout.addView(result);

            LinearLayout.LayoutParams resultparams=(LinearLayout.LayoutParams) result.getLayoutParams();
            resultparams.width=width;
            resultparams.height=height/8;
            result.setLayoutParams(resultparams);

            first=new BinaryNumber();
            second=new BinaryNumber();

            praxeis=new TableLayout(this);
            mainLayout.addView(praxeis);
            LinearLayout.LayoutParams praxeisparams=(LinearLayout.LayoutParams)praxeis.getLayoutParams();
            praxeisparams.leftMargin=width/20;
            praxeisparams.width=width-2*praxeisparams.leftMargin;
            praxeis.setLayoutParams(praxeisparams);

            row1=new TableRow(this);
            row2=new TableRow(this);
            row3=new TableRow(this);
            praxeis.addView(row1);
            praxeis.addView(row2);
            praxeis.addView(row3);
            zero=new ImageView(this);
            zero.setImageResource(R.drawable.zerobutton);
            row1.addView(zero);
            one=new ImageView(this);
            one.setImageResource(R.drawable.onebutton);
            row1.addView(one);
            plus=new ImageView(this);
            plus.setImageResource(R.drawable.plusbutton);
            row2.addView(plus);
            minus=new ImageView(this);
            minus.setImageResource(R.drawable.minusbutton);
            row2.addView(minus);
            clear=new ImageView(this);
            clear.setImageResource(R.drawable.backbutton);
            row3.addView(clear);
            equals=new ImageView(this);
            equals.setImageResource(R.drawable.equalsbutton);
            row3.addView(equals);


            View.OnTouchListener menuListener=new View.OnTouchListener() {
                @Override
                public boolean onTouch(View v, MotionEvent event) {

                    switch (event.getAction()) {
                        case MotionEvent.ACTION_DOWN: {
                            ImageView view = (ImageView) v;
                            //overlay is black with transparency of 0x77 (119)
                            view.setColorFilter(0x77000000, PorterDuff.Mode.SRC_ATOP);
                            view.invalidate();

                            break;
                        }
                        case MotionEvent.ACTION_UP:

                        case MotionEvent.ACTION_CANCEL: {
                            ImageView view = (ImageView) v;
                            //clear the overlay
                            view.clearColorFilter();
                            view.invalidate();
                            break;
                        }
                    }

                    return false;
                }

            };
            one.setClickable(true);one.setOnTouchListener(menuListener);
            zero.setClickable(true);zero.setOnTouchListener(menuListener);
            plus.setClickable(true);plus.setOnTouchListener(menuListener);
            minus.setClickable(true);minus.setOnTouchListener(menuListener);
            clear.setClickable(true);clear.setOnTouchListener(menuListener);
            equals.setClickable(true);equals.setOnTouchListener(menuListener);
            one.setOnClickListener(new View.OnClickListener()
            {

                @Override
                public void onClick(View v) {
                    if(whichTurn==0)
                    {
                        first.addDigit(1);
                        result.setText(""+first);
                    }
                    else
                    {
                        second.addDigit(1);
                        result.setText(""+second);
                    }

                }

            });

            zero.setOnClickListener(new View.OnClickListener()
            {

                @Override
                public void onClick(View v) {
                    if(whichTurn==0)
                    {
                        first.addDigit(0);
                        result.setText(""+first);
                    }
                    else
                    {
                        second.addDigit(0);
                        result.setText(""+second);
                    }

                }

            });
            clear.setOnClickListener(new View.OnClickListener()
            {

                @Override
                public void onClick(View v) {
                    if(whichTurn==0)
                    {
                        first.removeLastDigit();
                        result.setText(""+first);
                    }
                    else
                    {
                        second.removeLastDigit();
                        result.setText(""+second);
                    }

                }

            });
            minus.setOnClickListener(new View.OnClickListener()
            {

                @Override
                public void onClick(View v) {
                    whichTurn=1;
                    lastOperation=1;
                    result.setText("");
                    second=new BinaryNumber();
                }

            });
            plus.setOnClickListener(new View.OnClickListener()
            {

                @Override
                public void onClick(View v) {
                    whichTurn=1;
                    lastOperation=0;
                    result.setText("");
                    second=new BinaryNumber();

                }

            });
            equals.setOnClickListener(new View.OnClickListener()
            {

                @Override
                public void onClick(View v) {
                    whichTurn=0;
                    if(lastOperation==0)
                        first.addNumber(second);
                    else
                        first.subNumber(second);
                    lastOperation=0;
                    result.setText(""+first);
                    first=new BinaryNumber();
                }

            });
        }
    }